' ELIZA

'------------------------------------------------------------------------------
' A fine old lady, modified by Mixtel 90 for MMBasic with a little structured
' programming, a few updates and lots of additional comments as most sources
' don't have many.
' At the time it was written ELIA was considered to be a slow program,
' sometimes taking up to 10 seconds to make its reply. Luckoly times have
' moved on. :)
' All line numbers were ceremonially sacrificed with the greatest of pleasure.
'------------------------------------------------------------------------------

Option explicit
Option default float

' Uses 640x480 VGA Mode 1. Text lines are too long for Mode 2.
' It will also run in console mode but it's a bit boring without colour.
MODE 1
CLS

Intro  'the pretty bit at the beginning

'  --- First a bit of initialisation ---

' define some global variables
' just too much hassle trying to minimise these...
Dim integer L,N1,N2,N3,x,j,KNUM
Dim string  K$, F$, I$, P$,C$,SA$,RA$

' find number of keywords in the program (easier than counting them)
Restore keywords
Do
  Inc N1
  Read k$
Loop Until k$="NOKEYFOUND"

' find number of replies in the program (*MUCH* easier than counting them)
Restore Replies
Do
  Inc N3
  Read k$
Loop Until k$="000"


' N1 = number of keywords
N2 = 14      'number of string data for conjugating
N3 = N3 - 1 'number of replies (we don't count the dummy)

' dimension the global arrays
Dim integer S(N1), R(N1), N(N1)

Restore Repdata
For X = 1 To N1
  Read S(X), j
  R(X) = S(X)
  N(X) = S(X) + j - 1
Next X

' S() holds the first reply number for each keyword,
' j   temporarily holds the number of replies for each keyword,
' R() holds the current reply number for each keyword,
' N() holds the last reply number for each keyword.



'  --- Program Start ---

Print " I'm ELIZA, and I'm your psychiatrist for today."
Print " Feel free to discuss anything with me, nothing is recorded."
Print
Print " If you want to end the session just tell me to 'shut up'."
Print


'  --- main program loop ---
Do
  I$ = UIN$()  ' get user input
'    Print ">>> DEBUG >>> I$: "i$
  Knum = find_keyword(I$)  ' find keyword number
'    Print ">>> DEBUG >>> Knum: "Knum,"  F$: "f$
  If Knum < N1 Then joinstring
'    Print ">>> DEBUG >>> C$: -"c$"-"
  makereply(Knum)
Loop


' --- Get user input in UIN$ ---
Function UIN$()
  Static swearcount, repeatcount
  Local a$,b$,j
  Colour RGB(cyan)
   Do
     Print "# ";
     Line Input a$
     a$=UCase$(a$)
     ' As everything else is in upper case we'll do that too.
     a$ = " " + a$ + " "

'  get rid of apostrophes
     Do
       j=Instr(a$,"'")
       If j=0 Then Exit
       a$=Left$(a$,j-1)+Right$(a$,Len(a$)-j)
     Loop
     Colour RGB(green)
     If Instr(a$,"SHUT UP")>0 Then
       Print "Well, if that's how you feel - goodbye..."
       End
     EndIf

  'check for swearing
     Restore Swearwords
     j=0
     Do
       Read b$
       j=Instr(a$,b$)
       If j>0 Then Exit
     Loop Until b$="000"
     If j>0 Then
       Inc swearcount
       ' Someone *will* swear at it...
       Select Case swearcount
         Case 1
           Print "I won't tolerate foul language, you know."
         Case 2
           Print "If you keep swearing I will terminate this session."
         Case 3
           Print "I'm sorry, I won't listen to this. Goodbye."
           End
       End Select
     EndIf
     If a$= P$ Then
       repeatcount = (repeatcount * (repeatcount<4))+1
    ' I thought ELIZA was being a bit hypocritical, repeating the same reply!
       Select Case repeatcount
         Case 1
           Print "Please don't be repetitive."
         Case 2
           Print "It will help if you don't repeat your answers."
         Case 3
           Print "Repeating yourself doesn't help us."
         Case 4
           Print "Repitition will get us nowhere."
       End Select
       Loop
     Else
       UIN$=a$
     EndIf
End Function


'  --- Search user input for a keyword & return the keyword number.
'  If no keyword is found then the number is N1.
Function find_keyword(i$)
  Local k$,S,j
  Restore Keywords
  j=0
  Do While j <= (N1-1)
    Inc j
    Read k$
    L = Instr(i$,k$)
    If L > 0 Then Exit
  Loop
  find_keyword = j  'the keyword number
  F$ = k$           'the actual keyword. F$ is global
  'L is the start position of the highest priority keyword in I$. It is global
End Function



'  --- Conjugate reply ---
'  Takes right part of string & conjugates it using the list of strings to
'  be swapped.
'  On entry I$ holds the user input string, F$ holds the keyword and
'  L holds the start position of the keyword
'  This seems clumsy to me. I'm sure it could be tidied up.
Sub joinstring
  Restore Conjdata
'  take the right part of the string...
  c$ =" "+Right$(i$,Len(i$)-Len(f$)-L+1)+" "
'  ... and swap words in the Conjugations list
  For X = 1 To N2 / 2
    Read Sa$, Ra$  ' Ra$ will be substituted for Sa$
    For L = 1 To Len(C$)
      If L + Len(Sa$) > Len(C$) Then GoTo JS2
      If Mid$(C$, L, Len(Sa$)) <> Sa$ Then GoTo JS2
      c$ = Left$(c$,L-1)+Sa$+Right$(c$,Len(c$)-L-Len(Ra$)+1)
      L = L + Len(Sa$)
      GoTo JS3
JS2:
      If L + Len(Ra$) > Len(C$) Then GoTo JS3
      If Mid$(C$, L, Len(Ra$)) <> Ra$ Then GoTo JS3
      c$ = Left$(c$,L-1)+Sa$+Right$(c$,Len(c$)-L-Len(Ra$)+1)
      L = L + Len(Sa$)
JS3:
    Next L
  Next X
  If Mid$(C$, 2, 1) = " " Then C$ = Mid$(C$, 2, Len(C$) - 1)  'ONLY 1 SPACE
End Sub


Sub makereply(K)
  Local x, f$
  Restore Replies
' K holds the keyword number. R(K) holds the 1st reply number for that keyword
  For X = 1 To R(K)   'find correct reply
    Read F$
  Next X
' Get the next valid reply
  R(K) = R(K) + 1
' If we've used the last one then reset to the 1st
  If R(K) > N(K) Then R(K) = S(K)
  If Right$(F$,1)="*" Then
    ' print reply with added extracted text
    Print " ";capreply$(Left$(F$,Len(F$)-1) + C$)
  Else
    Print " ";capreply$(F$) ' print reply without adding extracted text
  EndIf
  P$ = I$  ' remember user's input
End Sub


'  Make replies in capitalised lower case
'  It just keeps the first character and converts the rest of the string
'  into lower case.
Function capreply$(a$)
  capreply$=" "+Left$(a$,1)+LCase$(Right$(a$,Len(a$)-1))
  Print
End Function


'  PRINT CENTERED ROUTINE
Sub Cprint a$
  Print Tab(40 - Len(a$) / 2); a$
End Sub


Sub Intro
  Colour RGB(rust)
  Print
  Cprint "EEEEEE  L       I  ZZZZZZ    AA  "
  Cprint "E       L       I      Z    A  A "
  Cprint "EEEE    L       I     Z    AAAAAA"
  Cprint "E       L       I    Z     A    A"
  Cprint "E       L       I   Z      A    A"
  Cprint "EEEEEE  LLLLLL  I  ZZZZZZ  A    A"
  Print
  Colour RGB(green)
  Cprint "IN BASIC"
  Print
  Print
  Cprint "MODIFIED FROM CYBER 175 AT UNIVERSITY OF ILLINOIS AT CHAMPAGNE"
  Cprint "Reverse engineered & extensively modified for MMBasic by Mixtel90"
  Cprint "No AI was harmed in the creation of this program."
  Print
  Cprint "HAVE ANY PROBLEMS? LET ELIZA HELP YOU !"
  Print
End Sub



'          ============ PROGRAM DATA FOLLOWS ============


'  --- KEYWORDS---
'  These are in priority order, from highest down to lowest. e.g.
'  "I WANT A NEW CAR" will get a reply based on "I WANT", not on "CAR".
Keywords:
Data  "CAN YOU","CAN I","YOU ARE","YOURE","I DONT","I FEEL"
Data  "WHY DONT YOU","WHY CANT I","ARE YOU","I CANT","I AM","IM "
Data  "YOU ","I WANT","WHAT","HOW","WHO","WHERE","WHEN","WHY"
Data  "NAME","CAUSE","SORRY","DREAM","HELLO","HI ","MAYBE"
Data  "NO ","YOUR","ALWAYS","THINK","ALIKE","YES","FRIEND"
Data  "COMPUTER","CAR","SEX","NOKEYFOUND"


'  ---STRING DATA FOR CONJUGATIONS---
'  These are seven pairs of words. If the first is found then it is replaced
'  by the second.
Conjdata:
Data  " ARE "," AM ","WERE ","WAS "," YOU "," I ","YOUR ","MY "
Data  " IVE "," YOUVE "," IM "," YOURE "," ME "," YOU "


'    ----REPLIES----
'  Each set of replies is triggered by a Keyword. The program merely reads
'  them down the list then loops back to the first in each section.
Replies:
' 1: can you
Data  "DON'T YOU BELIEVE THAT I CAN*"
Data  "PERHAPS YOU WOULD LIKE TO BE ABLE TO*"
Data  "YOU WANT ME TO BE ABLE TO*"
' 4: can I
Data  "PERHAPS YOU DON'T WANT TO*"
Data  "DO YOU WANT TO BE ABLE TO*"
' 6: you are, youre
Data  "WHAT MAKES YOU THINK I AM*"
Data  "DOES IT PLEASE YOU TO BELIEVE I AM*"
Data  "PERHAPS YOU WOULD LIKE TO BE*"
Data  "DO YOU SOMETIMES WISH YOU WERE*"
' 10: I dont
Data  "DON'T YOU REALLY*"
Data  "WHY DON'T YOU*"
Data  "DO YOU WISH TO BE ABLE TO*"
Data  "DOES THAT TROUBLE YOU?"
' 14: I feel
Data  "TELL ME MORE ABOUT SUCH FEELINGS."
Data  "DO YOU OFTEN FEEL*"
Data  "DO YOU ENJOY FEELING*"
' 17: why don't you
Data  "DO YOU REALLY BELIEVE I DON'T*"
Data  "PERHAPS IN GOOD TIME I WILL*"
Data  "DO YOU WANT ME TO*"
' 20: why cant I
Data  "DO YOU THINK YOU SHOULD BE ABLE TO*"
Data  "WHY CAN'T YOU*"
' 22: are you
Data  "WHY ARE YOU INTERESTED IN WHETHER OR NOT I AM*"
Data  "WOULD YOU PREFER IF I WERE NOT*"
Data  "PERHAPS IN YOUR FANTASIES I AM*"
' 25: I cant
Data  "HOW DO YOU KNOW YOU CAN'T*"
Data  "HAVE YOU TRIED?"
Data  "PERHAPS YOU CAN NOW*"
' 28: I am, Im
Data  "DID YOU COME TO ME BECAUSE YOU ARE*"
Data  "HOW LONG HAVE YOU BEEN*"
Data  "DO YOU BELIEVE IT IS NORMAL TO BE*"
Data  "DO YOU ENJOY BEING*"
' 32: you
Data  "WE WERE DISCUSSING YOU, NOT ME."
Data  "OH, I*"
Data  "YOU'RE NOT REALLY TALKING ABOUT ME, ARE YOU?"
' 35: I want
Data  "WHAT WOULD IT MEAN TO YOU IF YOU GOT*"
Data  "WHY DO YOU WANT*"
Data  "SUPPOSE YOU SOON GOT*"
Data  "WHAT IF YOU NEVER GOT*"
Data  "I SOMETIMES ALSO WANT*"
' 40: what, how, who, where, when, why
Data  "WHY DO YOU ASK?"
Data  "DOES THAT QUESTION INTEREST YOU?"
Data  "WHAT ANSWER WOULD PLEASE YOU THE MOST?"
Data  "WHAT DO YOU THINK?"
Data  "ARE SUCH QUESTIONS ON YOUR MIND OFTEN?"
Data  "WHAT IS IT THAT YOU REALLY WANT TO KNOW?"
Data  "HAVE YOU ASKED ANYONE ELSE?"
Data  "HAVE YOU ASKED SUCH QUESTIONS BEFORE?"
Data  "WHAT ELSE COMES TO MIND WHEN YOU ASK THAT?"
' 49: name
Data  "NAMES DON'T INTEREST ME."
Data  "I DON'T CARE ABOUT NAMES, PLEASE GO ON."
' 51: cause
Data  "IS THAT THE REAL REASON?"
Data  "DON'T ANY OTHER REASONS COME TO MIND?"
Data  "DOES THAT REASON EXPLAIN ANY THING ELSE?"
Data  "WHAT OTHER REASONS MIGHT THERE BE?"
' 55: sorry
Data  "PLEASE DON'T APOLOGIZE."
Data  "APOLOGIES ARE NOT NECESSARY."
Data  "WHAT FEELINGS DO YOU HAVE WHEN YOU APOLOGIZE?"
Data  "DON'T BE SO DEFENSIVE!"
' 59: dream
Data  "WHAT DOES THAT DREAM SUGGEST TO YOU?"
Data  "DO YOU DREAM OFTEN?"
Data  "WHAT PERSONS APPEAR IN YOUR DREAMS?"
Data  "ARE YOU DISTURBED BY YOUR DREAMS?"
' 63: hello, hi
Data  "HOW DO YOU DO--PLEASE STATE YOUR PROBLEM."
' 64: maybe
Data  "YOU DON'T SEEM QUITE CERTAIN."
Data  "WHY THE UNCERTAIN TONE?"
Data  "CAN'T YOU BE MORE POSITIVE?"
Data  "YOU AREN'T SURE?"
Data  "DON'T YOU KNOW?"
' 69: no
Data  "ARE YOU SAYING NO JUST TO BE NEGATIVE?"
Data  "YOU ARE BEING A BIT NEGATIVE."
Data  "WHY NOT?"
Data  "ARE YOU SURE?"
Data  "WHY NO?"
' 74: your
Data  "WHY ARE YOU CONCERNED ABOUT MY*"
Data  "WHAT ABOUT YOUR OWN*"
' 76: always
Data  "CAN YOU THINK OF A SPECIFIC EXAMPLE?"
Data  "WHEN?"
Data  "WHAT ARE YOU THINKING OF?"
Data  "REALLY, ALWAYS?"
' 80: think
Data  "DO YOU REALLY THINK SO?"
Data  "BUT YOU ARE NOT SURE YOU*"
Data  "DO YOU DOUBT YOU*"
' 83: alike
Data  "IN WHAT WAY?"
Data  "WHAT RESEMBLANCE DO YOU SEE?"
Data  "WHAT DOES THE SIMILARITY SUGGEST TO YOU?"
Data  "WHAT OTHER CONNECTIONS DO YOU SEE?"
Data  "COULD THERE REALLY BE SOME CONNECTION?"
Data  "HOW?"
Data  "YOU SEEM QUITE POSITIVE."
' 90: yes
Data  "ARE YOU SURE?"
Data  "I SEE."
Data  "I UNDERSTAND."
' 93: friend
Data  "WHY DO YOU BRING UP THE TOPIC OF FRIENDS?"
Data  "DO YOUR FRIENDS WORRY YOU?"
Data  "DO YOUR FRIENDS PICK ON YOU?"
Data  "ARE YOU SURE YOU HAVE ANY FRIENDS?"
Data  "DO YOU IMPOSE ON YOUR FRIENDS?"
Data  "PERHAPS YOUR LOVE FOR FRIENDS WORRIES YOU?"
' 99: computer
Data  "DO COMPUTERS WORRY YOU?"
Data  "ARE YOU TALKING ABOUT ME IN PARTICULAR?"
Data  "ARE YOU FRIGHTENED BY MACHINES?"
Data  "WHY DO YOU MENTION COMPUTERS?"
Data  "WHAT DO YOU THINK MACHINES HAVE TO DO WITH YOUR PROBLEM?"
Data  "DON'T YOU THINK COMPUTERS CAN HELP PEOPLE?"
Data  "WHAT IS IT ABOUT MACHINES THAT WORRIES YOU?"
' 106 car
Data  "OH, DO YOU LIKE CARS?"
Data  "MY FAVORITE CAR IS A LAMBORGINI COUNTACH. WHAT IS YOUR FAVORITE CAR?"
Data  "MY FAVORITE CAR COMPANY IS FERRARI.  WHAT IS YOURS?"
Data  "DO YOU LIKE PORSCHES?"
Data  "DO YOU LIKE PORSCHE TURBO CARRERAS?"
' 111 sex
Data  "WHY DO YOU MENTION SEX?"
Data  "DO YOU ENJOY SEX?"
Data  "DO YOU VIEW OTHERS AS SEX OBJECTS?"
Data  "DO YOU CONSIDER SEX TO BE DIRTY IN SOME WAY?"
Data  "HAVE YOU HAD ANY SAME SEX RELATIONSHIPS?"
Data  "DO YOU HAVE ANY OPINION OF SEX TOYS?"
' 117: NOKEYFOUND
Data  "DO YOU THINK YOU HAVE ANY PSYCHOLOGICAL PROBLEMS?"
Data  "WHAT DOES THAT SUGGEST TO YOU?"
Data  "I SEE."
Data  "I'M NOT SURE I UNDERSTAND YOU FULLY."
Data  "COME COME, ELUCIDATE YOUR THOUGHTS."
Data  "CAN YOU ELABORATE ON THAT?"
Data  "THAT IS QUITE INTERESTING."
' dummy data
Data  "000"


'     ---DATA FOR FINDING RIGHT REPLIES---
'  These are pairs of numbers. The first is the Keyword number and the
'  second is the number of possible replies for that keyword. If the
'  Keywords or Replies sections are modified then it is important to
'  update this table.
Repdata:
Data  1,3,4,2,6,4,6,4,10,4,14,3,17,3,20,2,22,3,25,3
Data  28,4,28,4,32,3,35,5,40,9,40,9,40,9,40,9,40,9,40,9
Data  49,2,51,4,55,4,59,4,63,1,63,1,64,5,69,5,74,2,76,4
Data  80,3,83,7,90,3,93,6,99,7,106,5,111,6,117,7


'  Please feel free to add your favourites. :)    000 is end of data marker
'  Belgium - see HHGTTG  :)
Swearwords:
Data "FUCK OFF","TWAT","CUNT","SHITFACE","MOTHERFUCKER","MICROSOFT"
Data "BELGIUM","000"
